package elvisDoc;
import java.io.*;
import java.io.IOException;
import java.io.File;
import java.util.Hashtable;
import java.util.*;

class elvisDoc {
	
	static String defaultMasterParent = "root";
	public String masterParent = defaultMasterParent;
	//public elvisDocItem[] docList;
	public Hashtable<String, elvisDocItem> docList;
	
	
	public int docItems = 10;
	public int curDocItemInd = -1;
	
	public elvisDoc() {
			
		docList = new Hashtable<String, elvisDocItem>();
		
	}
	
	/**
	 * There are now parameters for this: 'html' and 'serializable' specifies
	 * what type of file to write; can be expanded later.
	 * Defaults to 'html.'.  DEPRECATED -  this should generate everything.  AR
	 * @param args
	 * @throws IOException
	 */
	public static void main(String args[]) throws IOException {
	
		elvisDoc ed = new elvisDoc();
	
		String loadPath = System.getProperty("user.dir")+File.separator+"lib"+File.separator+"java";
		File userFile = new File(loadPath);


		String[] fileList = userFile.list();
		
		int curFile = 0;
		//System.out.println(System.getProperty("user.dir"));
		if(userFile.isDirectory()) {
			System.out.println("Loading from " + loadPath + " " + fileList.length + " files.");
			
			while(curFile < fileList.length) {
				ed.getDocFromFile(loadPath + File.separator + fileList[curFile]);
				curFile++;
			}
			
			ed.addRoot(defaultMasterParent);
			
			System.out.println("Linking...");
			ed.linkDocList();
			ed.normalizeAttributes();
			//ed.printItems();
			
		
				System.out.println("Creating HTML files...");
				ed.makeHTML();
				System.out.println("Creating Serializable file...");
				ed.makeSerializeable();
		}
		else {
			System.out.println("Error: You must supply a valid directory.");
		}
			
		
		System.out.println("Done.");
	}
	public void makeHTML() throws IOException {
		
		new ElvisDocHTMLDoc(docList, masterParent, System.getProperty("user.dir"));
		
	}
	
	
	
	public void makeSerializeable() throws IOException {
		new ElvisDocSerializeDoc(docList,System.getProperty("user.dir"));
	}
	public void printItems() {
		
		Enumeration<elvisDocItem> e = docList.elements();
		
		while(e.hasMoreElements()) {
			elvisDocItem edi = (elvisDocItem)e.nextElement();
			System.out.println("Name:" + edi.name + ":");
			System.out.println("Parent:" + edi.parentName + ":");
			if(!edi.name.equals(masterParent)) {
				System.out.println("CParent:" + edi.parent.name + ":");
			}
			System.out.println("Description:" + edi.getDescription(true) + ":");
			
			Enumeration<elvisDocItem> eChildren;
			eChildren  = edi.children.elements();
			
			while(eChildren.hasMoreElements()) {
				elvisDocItem ediChild = (elvisDocItem)eChildren.nextElement();
				System.out.println("Child:" + ediChild.name + ":");
			}
			
			Enumeration<elvisDocAttribute> eAttrs;
			eAttrs = edi.attrs.elements();
			
			while(eAttrs.hasMoreElements()) {
				elvisDocAttribute ediAttr = (elvisDocAttribute)eAttrs.nextElement();
				
				System.out.println("Attribute:" + ediAttr.name + ":");
				System.out.println("Attribute:" + ediAttr.getDescription(true) + ":");
			}
			System.out.println("-------------");
		}
	}

	
	/*
	public void addToDocList(elvisDocItem edi) {
		
		if(curDocItemInd == -1) {
			docList = new elvisDocItem[docItems];
			docList[0] = edi;
			curDocItemInd = 1;
		}
		else if(curDocItemInd < docItems) {
			docList[curDocItemInd] = edi;
			curDocItemInd++;
		}
		else {
			docItems = docItems + 5;
			elvisDocItem[] tmpItems = new elvisDocItem[docItems];
			System.arraycopy(docList, 0, tmpItems, 0, docList.length);
			docList = tmpItems;
		}
		
	}
	*/
	

	public void normalizeAttributes() {
		passDownAttributes(docList.get(masterParent));
	}
	
	public void passDownAttributes(elvisDocItem edi) {
		
		Enumeration<elvisDocItem> eChildren = edi.children.elements();
		
		while(eChildren.hasMoreElements()) {
			
			elvisDocItem curChild = eChildren.nextElement();
			Enumeration<elvisDocAttribute> eAttrs = edi.attrs.elements();
			
			while(eAttrs.hasMoreElements()) {
				elvisDocAttribute curAttr = eAttrs.nextElement();
				
				if(curChild.attrs.containsKey(curAttr.name)) {
					elvisDocAttribute tmpAttr = curChild.attrs.get(curAttr.name);
					
					if(tmpAttr.defaultValue.equals("")) tmpAttr.defaultValue = curAttr.defaultValue;
					if(tmpAttr.getDescription(true).equals("")) tmpAttr.setDescription(curAttr.getDescription(false));
				}
				else {
					curChild.attrs.put(curAttr.name, curAttr);
				}
			}
			passDownAttributes(curChild);
		}		
	}
	
	public void linkDocList() {
		
		elvisDocItem mp = docList.get(masterParent);
		
		Enumeration<elvisDocItem> e = docList.elements();
		e = docList.elements();
		
		while(e.hasMoreElements()) {
			elvisDocItem curEdi = e.nextElement();

			if(curEdi.parentName.equals("")) {
				if(!curEdi.name.equals(masterParent)) {
					curEdi.parentName = mp.name;
					curEdi.parent = mp;
					mp.children.put(curEdi.name, curEdi);
				}
				else {
					curEdi.parentName = "defaultMasterParent";
					
				}
					
			}
			else {
				//System.out.println("Looking for " + curEdi.parentName);
				elvisDocItem foundParent = docList.get(curEdi.parentName);
				curEdi.parent = foundParent;
				foundParent.children.put(curEdi.name, curEdi);
			}
		}
		//System.out.println("Master Parent = " + mp.name);
	
	}
	public void addRoot(String rootName) {
		
		elvisDocItem docStruc = new elvisDocItem();
		docStruc.name = rootName;
		docList.put(rootName, docStruc);
	}
	
	public void getDocFromFile(String fileName) throws IOException {
		
		elvisDocItem docStruc = new elvisDocItem();
		
		//if(!fileName.substring(fileName.length() - 5).equals(".java")) return;
		if(!fileName.contains(".java")) return;
		
		BufferedReader fr = new BufferedReader(new FileReader(fileName));
		
		boolean receivingAttrs = false;
		boolean gotParent = false;
		boolean commentsOpen = false;
		
		while(fr.ready()) {
			
			elvisLineItem eli = new elvisLineItem(fr.readLine());
			//if(fileName.contains("Button.java")) System.out.println(eli.originalLine);
			if(eli.commentsOpen == 1) {
				//System.out.println("Comments opened.");
				commentsOpen = true;
			}
			if(eli.commentsOpen == -1) {
				//System.out.println("Comments closed.");
				commentsOpen = false;
				
			}
			
			if(eli.type != eli.getItNothing()) {
				
				eli = new elvisLineItem(getFullLine(fr, eli.originalLine, commentsOpen));
				
				if(eli.type == eli.getItWidget()) {
					docStruc.name = eli.description;
					receivingAttrs = false;
				}
				else if(eli.type == eli.getItParent() && gotParent == false) {
					docStruc.parentName = eli.description;
					gotParent = true;
					receivingAttrs = false;
				}
				else if(eli.type == eli.getItDefaultValue()) {		
					docStruc.addAttribute(eli.name, "", eli.description);
					receivingAttrs = false;
				}
				else if(eli.type == eli.getItAttr()) {
					receivingAttrs = true;
				}
				else if(eli.type == eli.getItSpec()) {
					
					if(receivingAttrs == true) {
						docStruc.addAttribute(eli.name, eli.description, "");
					}
					else if(docStruc.name == null) {
						docStruc.setDescription(eli.name.concat(" " + eli.description));
					}
				}
			}
		}
		fr.close();
		//System.out.println(docStruc.name);
		//System.out.println(docStruc.name);
		//System.out.println(docStruc.name == null);
		if(docStruc.name != null) docList.put(docStruc.name, docStruc);
	}
	
	public String getFullLine(BufferedReader fr, String originalLine, boolean commentsOpen) throws IOException {
		
		while(fr.ready()) {
			
			fr.mark(1000);
			
			String nl = fr.readLine().trim();
			
			if(commentsOpen) {
				if(nl.contains("*/")) {
					originalLine = originalLine.concat(" " + nl.substring(0, nl.indexOf("*/")).trim());
					fr.reset();
					return originalLine;
				}
				else if(nl.substring(0, 1).equals("*")) {
					//System.out.println("TEST:" + nl);
					if(nl.substring(1).trim().length() != 0) {
						originalLine = originalLine.concat(" " + nl.substring(1).trim());
					}
					else {
						fr.reset();
						return originalLine;
					}
					
				}
				else {
					//System.out.println("Here!");
					originalLine = originalLine.concat(" " + nl.trim());
				}
			}
			else {
				if(nl.length() < 3) {
					fr.reset();
					return originalLine;
				}
				else if(nl.substring(0, 2).equals("//")) {
					
					if(!nl.contains("@EName"))
						originalLine = originalLine.concat(" " + nl.substring(2).trim());
					fr.reset();
					
					return originalLine;
					
					
				}
				else {
					fr.reset();
					return originalLine;
				}
			}
		}

		//System.out.println("Returning...(" + fr.ready() + ")");
		return originalLine;
	}
	
}