package errors;

/** Abstract superclass for errors caused by options. */
public abstract class BadOptionException extends GUIFileException {
    /** The line number on which the option was declared. */
    public final int lineNum;
    /** The name of the erroneous option. */
    public final String name;

    /** @param msg The error message. (Should be computed by the subclass.)
     *  @param lineNum The line number of the error.
     *  @param name The name of the erroneous option. */
    public BadOptionException(String msg, int lineNum, String name) {
        super(msg, lineNum);
        this.lineNum = lineNum;
        this.name = name;
    }
}
