package errors;

/** An unrecognized attribute name.
 *  Has no variables beyond those of the superclass, but formats the message
 *  according to the line number and the option name. */
public class BadOptionNameException extends BadOptionException {
    /** @param lineNum The widget with the invalid attribute name. 
     *  @param name The invalid attribute name. */
    public BadOptionNameException(int lineNum, String name) {
        super(formatMsg(name), lineNum, name);
    }
    
    private static String formatMsg(String name) {
        return String.format("%s: unrecognized option name", name);
    }
}
