package errors;

/**
 * An error caused by some kind of bug in our library code. This is an unchecked
 * exception because it should not be thrown in the normal course of events.
 * (Note that there's nothing abnormal about bad input, so ideally no .gui file
 * should elicit this exception.)
 */
public class BadWidgetDefinitionException extends RuntimeException {
	/**
	 * @param cause The exception thrown by the library code.
	 */
	public BadWidgetDefinitionException(Throwable cause) {
		super(cause);
	}
    /**
     * @param msg The error message.
     */
    public BadWidgetDefinitionException(String msg) {
        super(msg);
    }
    /**
     * @param msg The error message.
     * @param cause The exception thrown by the library code.
     */
    public BadWidgetDefinitionException(String msg, Throwable cause) {
        super(msg, cause);
    }
}
